﻿Type=Service
Version=2.30
StartAtBoot=False
@EndOfDesignText@
'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim GPS1 As GPS
	Dim GPS_Str_Next_Start	As String
End Sub
Sub Service_Create
	'
	If Main.SysLogEnable = "S" Then
		Rutinas.Write_Log("Service.GPS","Service_Create")
	End If
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	Dim lc_Gps_Time		As Int
	Dim lc_Minutes		As Long
	Dim lc_Current_Hour	As Int
	Dim lc_Next_Start	As Long
	Dim lcSqlComando	As String
	Dim Notification_Tel As Notification
	'
	If Main.SysLogEnable = "S" Then
		Rutinas.Write_Log("Service.GPS","Service_Start")
	End If
	'
	lc_Next_Start		= DateTime.Now + (Main.SysGPSTime * DateTime.TicksPerMinute)
	lc_Current_Hour		= DateTime.GetHour(DateTime.Now)
	GPS_Str_Next_Start	= Rutinas.Get_Format_Date(lc_Next_Start, Main.SysFormatoFecha)
	'
	If lc_Current_Hour >= Main.SysGPSBeginHour AND lc_Current_Hour <= Main.SysGPSEndHour Then
		'
		If Main.SysLogEnable = "S" Then
			Rutinas.Write_Log("Service.GPS","Stop previos GPS")
		End If
		GPS1.Stop
		'
		' Cancel previos schedule (if exists)
		CancelScheduledService("")
		'
		If Main.SysLogEnable = "S" Then
			Rutinas.Write_Log("Service.GPS","Next Schedule : " & GPS_Str_Next_Start)
		End If
		'
		Try
			StartServiceAt("", lc_Next_Start, True)
		Catch
			Rutinas.Write_Log("Service.GPS","Error in Schedule " & LastException.Message)
		End Try
	Else
		If Main.SysLogEnable = "S" Then
			Rutinas.Write_Log("Service.GPS","Do Not Schedule")
			Rutinas.Write_Log("Service.GPS","Actual Time :" & NumberFormat2(lc_Current_Hour,1,0,0,False))
			Rutinas.Write_Log("Service.GPS","SysGPSBeginHour :" & NumberFormat2(Main.SysGPSBeginHour,1,0,0,False))
			Rutinas.Write_Log("Service.GPS","SysGPSEndHour :" & NumberFormat2(Main.SysGPSEndHour,1,0,0,False))
		End If
	End If
	'
	GPS1.Initialize("GPS1")
	'
	If GPS1.GPSEnabled = False Then
		'
		If Main.SysLogEnable = "S" Then
			Rutinas.Write_Log("Service.GPS","GPS Disable")
		End If
		'
		Main.GlbGPSOk			= False
		'
		Main.GlbGPSEstado		= "I"
		Main.GlbGPSLatitud		= ""
		Main.GlbGPSLongitud		= ""
		Main.GlbGPSDireccion	= ""
		Main.GlbGPSVelocidad	= ""
		Main.GlbGPSAltitud		= ""
		Main.GlbGPSPrecision	= ""
		'
		' Mandar mensaje de activar el GPS
		Notification_Tel.Initialize
		Notification_Tel.Icon		= "icon"
		Notification_Tel.SetInfo("GPS Disable", "Must enable GPS", "") 
		Notification_Tel.AutoCancel	= True
		Notification_Tel.Notify(1)
		'
		Store_In_Data_Base
	Else
		'
		If Main.SysLogEnable = "S" Then
			Rutinas.Write_Log("Service.GPS","GPS Start")
		End If
		'
		Main.GlbGPSEstado	= "A"
		' Get a minute for "process" the data
		lc_Gps_Time	= (Main.SysGPSTime-1) * 1000
		'
		If Main.SysLogEnable = "S" Then
			Rutinas.Write_Log("Service.GPS","Start : " & NumberFormat2(lc_Gps_Time,1,2,0,True) )
		End If
		'
		GPS1.Start (lc_Gps_Time, 0)
	End If
	'
End Sub

Sub Service_Destroy
	'
	If Main.SysLogEnable = "S" Then
		Rutinas.Write_Log("Service.GPS","Service Destroy")
	End If
	'
End Sub

Sub GPS1_LocationChanged (Location1 As Location)
	Dim lc_Minutes		As Long
	'
	If Main.SysLogEnable = "S" Then
		Rutinas.Write_Log("Service.GPS","Begin of LocationChanged")
	End If
	'
	' Check if ONE minute elapsed
	'
	lc_Minutes	= DateTime.Now - Main.GlbGPSFecha
	If lc_Minutes >= DateTime.TicksPerMinute Then
	'
		If Main.SysLogEnable = "S" Then
			Rutinas.Write_Log("Service.GPS","MORE than one minute")
		End If
		'
		Main.GlbGPSLatitud		= Location1.Latitude
		Main.GlbGPSLongitud		= Location1.Longitude
		Main.GlbGPSDireccion	= Location1.Bearing
		Main.GLBGPSVelocidad	= Location1.Speed
		Main.GLBGPSAltitud		= Location1.Altitude
		Main.GLBGPSPrecision	= Location1.Accuracy
		'
		If Main.SysLogEnable = "S" Then
			Rutinas.Write_Log("Service.GPS","Lat: " & Main.GlbGPSLatitud & " Long: " & Main.GlbGPSLongitud)
		End If
		'
		GPS1.Stop
		Main.GlbGPSFecha	= DateTime.Now
		'
		Store_In_Data_Base
	Else
		Rutinas.Write_Log("Service.GPS","LESS than one minute (do nothing)")
	End If
	'
	GPS1.Stop
	StopService("")
	'
	If Main.SysLogEnable = "S" Then
		Rutinas.Write_Log("Service.GPS","End of LocationChanged")
	End If	
End Sub

Sub Store_In_Data_Base
	Dim lcMinutos		As Double
	Dim lcSqlComando	As String
	'
	If Main.SysLogEnable = "S" Then
		Rutinas.Write_Log("Service.GPS","Store in Data Base")
	End If
	'
	lcSqlComando = "INSERT INTO sg_t_gps (fecha_hora, latitud, longitud, direccion, velocidad, altitud, precision, estado_gps, fecha_hora_envio) values (" & _
								"^" & Rutinas.Get_Format_Date(DateTime.Now, Main.SysFormatoFecha) & "^, " & _
								"^" & Main.GlbGPSLatitud & "^, " & _
								"^" & Main.GlbGPSLongitud & "^, " & _
								"^" & Main.GlbGPSDireccion & "^, " & _
								"^" & Main.GLBGPSVelocidad & "^, " & _
								"^" & Main.GLBGPSAltitud & "^, " & _
								"^" & Main.GLBGPSPrecision & "^, " & _
								"^" & Main.GlbGPSEstado & "^, " & _
								"^" & GPS_Str_Next_Start & "^)"
	lcSqlComando	= lcSqlComando.Replace("^", Main.GlbComillas)
	Main.DBGPS.ExecNonQuery(lcSqlComando)
	'
	Main.GlbGPSFecha	= DateTime.Now
	Main.GlbGPSOk		= True
	'
	If Main.SysLogEnable = "S" Then
		Rutinas.Write_Log("Service.GPS","End of Store in Data Base")
	End If
	'
	GPS1.Stop
	StopService("")
End Sub
