﻿Type=StaticCode
Version=2.30
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Get_Format_Date (ParFecha As Long, ParFormato As String)
	Dim lcResultado As String
	lcResultado	= ""
	'
	Select ParFormato 
		Case "YYYYMMDD"
			lcResultado	= NumberFormat2(DateTime.GetYear(ParFecha),4,0,0,False) & _
							NumberFormat2(DateTime.GetMonth(ParFecha),2,0,0,False) & _
							NumberFormat2(DateTime.GetDayOfMonth(ParFecha),2,0,0,False)
		Case "YYYYMMDD HHMMSS"
			lcResultado	= NumberFormat2(DateTime.GetYear(ParFecha),4,0,0,False) & _
							NumberFormat2(DateTime.GetMonth(ParFecha),2,0,0,False) & _
							NumberFormat2(DateTime.GetDayOfMonth(ParFecha),2,0,0,False) & " " & _
							NumberFormat2(DateTime.GetHour(ParFecha),2,0,0,False) & _
							NumberFormat2(DateTime.GetMinute(ParFecha),2,0,0,False) & _
							NumberFormat2(DateTime.GetSecond(ParFecha),2,0,0,False)
		Case "YYYY-MM-DD HH:MM:SS"
			lcResultado	= NumberFormat2(DateTime.GetYear(ParFecha),4,0,0,False) & "-" & _
							NumberFormat2(DateTime.GetMonth(ParFecha),2,0,0,False) & "-" & _
							NumberFormat2(DateTime.GetDayOfMonth(ParFecha),2,0,0,False) & " " & _
							NumberFormat2(DateTime.GetHour(ParFecha),2,0,0,False) & ":" & _
							NumberFormat2(DateTime.GetMinute(ParFecha),2,0,0,False) & ":" & _
							NumberFormat2(DateTime.GetSecond(ParFecha),2,0,0,False)
		Case "DD-MM-YYYY"
			lcResultado	= NumberFormat2(DateTime.GetDayOfMonth(ParFecha),2,0,0,False) & "-" & _
							NumberFormat2(DateTime.GetMonth(ParFecha),2,0,0,False) & "-" & _
							NumberFormat2(DateTime.GetYear(ParFecha),4,0,0,False)
		Case "DD-MM-YYYY HH:MM:SS"
			lcResultado	= NumberFormat2(DateTime.GetDayOfMonth(ParFecha),2,0,0,False) & "-" & _
							NumberFormat2(DateTime.GetMonth(ParFecha),2,0,0,False) & "-" & _
							NumberFormat2(DateTime.GetYear(ParFecha),4,0,0,False) & " " & _
							NumberFormat2(DateTime.GetHour(ParFecha),2,0,0,False) & ":" & _
							NumberFormat2(DateTime.GetMinute(ParFecha),2,0,0,False) & ":" & _
							NumberFormat2(DateTime.GetSecond(ParFecha),2,0,0,False)
		Case "DD-MM-YYYY HH:MM"
			lcResultado	= NumberFormat2(DateTime.GetDayOfMonth(ParFecha),2,0,0,False) & "-" & _
							NumberFormat2(DateTime.GetMonth(ParFecha),2,0,0,False) & "-" & _
							NumberFormat2(DateTime.GetYear(ParFecha),4,0,0,False) & " " & _
							NumberFormat2(DateTime.GetHour(ParFecha),2,0,0,False) & ":" & _
							NumberFormat2(DateTime.GetMinute(ParFecha),2,0,0,False)
		Case Else
			Write_Log ("Rutinas.Get_Format_Date", "Formato de Fecha Invalido (" & ParFormato & ")")
	End Select
	'
	Return lcResultado
End Sub

Sub Write_Log (ParamPrograma As String, ParamInfo As String)
	Dim lcSqlComando As String
	lcSqlComando = "INSERT INTO sg_t_log (programa, fecha_hora, info) values (" & _
								"^XXParamProgramaXX^," & _
								"^" & Get_Format_Date(DateTime.Now, Main.SysFormatoFecha) & "^, " & _
								"^XXParamInfoXX^)"
	lcSqlComando	= lcSqlComando.Replace("XXParamProgramaXX", ParamPrograma)
	lcSqlComando	= lcSqlComando.Replace("XXParamInfoXX", ParamInfo)
	lcSqlComando	= lcSqlComando.Replace("^", Main.GlbComillas)
	'
	If Main.DBGPS.IsInitialized = True Then
		Main.DBGPS.ExecNonQuery(lcSqlComando)
	Else
		Log (lcSqlComando)
		Log ("Rutinas.Write_Log --- Database is NOT open")
	End If
	'
End Sub

Sub Open_DataBase (Directorio As String, DBName As String)
	Dim lcResult As Boolean
	'
	If File.Exists(Directorio, DBName) = True Then
		' Open the data base
		Main.DBGPS.Initialize(Directorio, DBName, False)
		If Main.DBGPS.IsInitialized = True Then
			Log ("Rutinas.Open_DataBase -- Database is Open")
			lcResult	= True
		Else
			Log ("Rutinas.Open_DataBase -- Cannot open Database, file NOT Exists")
			lcResult	= False
		End If
	Else
		If IsPaused(Main) = False Then
			Msgbox("Cannot open Database, file NOT Exists", "ERROR")
		Else
			Log ("Rutinas.Open_DataBase -- Cannot open Database, file NOT Exists")
		End If
		lcResult	= False
	End If
	'
	Return lcResult
End Sub
